package com.dcsoft.system.controller;

import java.util.List;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.dcsoft.system.domain.SysBranch;
import com.dcsoft.system.face.service.IIDaasService;
import com.dcsoft.system.service.ISysBranchService;
import org.apache.commons.lang3.ArrayUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import com.dcsoft.common.core.constant.UserConstants;
import com.dcsoft.common.core.utils.StringUtils;
import com.dcsoft.common.core.web.controller.BaseController;
import com.dcsoft.common.core.web.domain.AjaxResult;
import com.dcsoft.common.log.annotation.Log;
import com.dcsoft.common.log.enums.BusinessType;
import com.dcsoft.common.security.annotation.RequiresPermissions;
import com.dcsoft.common.security.utils.SecurityUtils;
import com.dcsoft.system.api.domain.SysDept;
import com.dcsoft.system.service.ISysDeptService;

/**
 * 部门信息
 *
 * @author dcsoft
 */
@RestController
@RequestMapping("/dept")
public class SysDeptController extends BaseController
{
    @Autowired
    private ISysDeptService deptService;

    @Autowired
    private ISysBranchService sysBranchService;

    @Autowired
    private IIDaasService iDaasService;

    /**
     * 获取部门列表
     */
    @RequiresPermissions("system:dept:list")
    @GetMapping("/list")
    public AjaxResult list(SysDept dept)
    {
        List<SysDept> depts = deptService.selectDeptList(dept);
        return success(depts);
    }

    /**
     * 查询部门列表（排除节点）
     */
    @RequiresPermissions("system:dept:list")
    @GetMapping("/list/exclude/{deptId}")
    public AjaxResult excludeChild(@PathVariable(value = "deptId", required = false) Long deptId)
    {
        List<SysDept> depts = deptService.selectDeptList(new SysDept());
        depts.removeIf(d -> d.getDeptId().intValue() == deptId || ArrayUtils.contains(StringUtils.split(d.getAncestors(), ","), deptId + ""));
        return success(depts);
    }

    /**
     * 根据部门编号获取详细信息
     */
    @RequiresPermissions("system:dept:query")
    @GetMapping(value = "/{deptId}")
    public AjaxResult getInfo(@PathVariable Long deptId)
    {
        deptService.checkDeptDataScope(deptId);
        return success(deptService.selectDeptById(deptId));
    }

    /**
     * 新增部门
     */
    @RequiresPermissions("system:dept:add")
    @Log(title = "部门管理", businessType = BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@Validated @RequestBody SysDept dept)
    {
        if (!deptService.checkDeptNameUnique(dept))
        {
            return error("新增部门'" + dept.getDeptName() + "'失败，部门名称已存在");
        }

        dept.setCreateBy(SecurityUtils.getUsername());
        int i=deptService.insertDept(dept);
        //查询上级部门绑定被企业园区绑定获取到企业园区的id
        try {
            SysBranch sysBranch =sysBranchService.selectSysBranchByDeptId(dept.getParentId());
            if(sysBranch!=null){
                SysBranch sysBranch1=new SysBranch();
                sysBranch1.setDeptId(dept.getDeptId());
                sysBranch1.setName(dept.getDeptName());
                sysBranch1.setParentId(sysBranch.getId());
                sysBranch1.setPhone(dept.getPhone());
                sysBranch1.setAncestors(dept.getAncestors());
                sysBranchService.insertSysBranch(sysBranch1);
            }
        }catch (Exception e){
            e.printStackTrace();
        }

        return toAjax(i);
    }

    /**
     * 修改部门
     */
    @RequiresPermissions("system:dept:edit")
    @Log(title = "部门管理", businessType = BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@Validated @RequestBody SysDept dept)
    {
        Long deptId = dept.getDeptId();
        deptService.checkDeptDataScope(deptId);
        if (!deptService.checkDeptNameUnique(dept))
        {
            return error("修改部门'" + dept.getDeptName() + "'失败，部门名称已存在");
        }
        else if (dept.getParentId().equals(deptId))
        {
            return error("修改部门'" + dept.getDeptName() + "'失败，上级部门不能是自己");
        }
        else if (StringUtils.equals(UserConstants.DEPT_DISABLE, dept.getStatus()) && deptService.selectNormalChildrenDeptById(deptId) > 0)
        {
            return error("该部门包含未停用的子部门！");
        }
        dept.setUpdateBy(SecurityUtils.getUsername());
        return toAjax(deptService.updateDept(dept));
    }

    /**
     * 删除部门
     */
    @RequiresPermissions("system:dept:remove")
    @Log(title = "部门管理", businessType = BusinessType.DELETE)
    @DeleteMapping("/{deptId}")
    public AjaxResult remove(@PathVariable Long deptId)
    {
        if (deptService.hasChildByDeptId(deptId))
        {
            return warn("存在下级部门,不允许删除");
        }
        if (deptService.checkDeptExistUser(deptId))
        {
            return warn("部门存在用户,不允许删除");
        }
        deptService.checkDeptDataScope(deptId);
        return toAjax(deptService.deleteDeptById(deptId));
    }

    /**
     * 获取部门列表
     */
    @GetMapping("/syncDept")
    public AjaxResult syncDept()
    {
        //同步获取IDaas同步数据
        int pageNo=0;
        Integer num=organizationList(pageNo);
        return success(num);
    }

    Integer organizationList(Integer pageNo){
        String data=iDaasService.organizationList(pageNo);
        JSONObject json= JSONObject.parseObject(data);
        //进行数据处理
        if("200".equals(json.get("code")+"")){
            JSONObject datas= (JSONObject) json.get("data");
            JSONArray organizations= (JSONArray) datas.get("organizations");
            for(int i=0;i<organizations.size();i++){
                JSONObject organization = (JSONObject) organizations.get(i);
                SysDept dept=new SysDept();
                String parentExternalId=organization.get("parentExternalId")+"";
                //根据父级parentExternalId查询上级机构信息
                SysDept depts=deptService.findByParentExternalId(parentExternalId);
                if(depts!=null){
                    SysDept dept1=deptService.findByParentExternalId(organization.get("externalId")+"");
                    if(dept1==null){
                        dept.setDeptName( organization.get("organizationName")+"");
                        dept.setExternalId(organization.get("externalId")+"");
                        dept.setParentId(depts.getDeptId());
                        deptService.insertDept(dept);
                    }else{
                        dept.setDeptName( organization.get("organizationName")+"");
                        dept.setExternalId(organization.get("externalId")+"");
                        dept.setParentId(depts.getDeptId());
                        dept.setDeptId(dept1.getDeptId());
                        deptService.updateDept(dept);
                    }
                }
            }
            pageNo++;
            Integer total=Integer.parseInt(datas.get("total")+"");
            if(total>pageNo*20){
                organizationList(pageNo);
            }

        }
        return pageNo;
    }
}
